<script>
import {useStore} from "vuex";
import {HOST_API} from "@/vars";
import EventBus from "@/utils/event-bus";

export default {
  name: 'CategoriesList',
  setup() {
    const store = useStore()
    return {
      store,
    }
  },
  data: () => ({
    categories: null,
  }),
  async created() {
    await this.getCategories()
  },
  computed: {
  },
  mounted() {
    this.role = this.store.state.profile.role;

    let instance = this;
    EventBus.on('updated-list-categories', function (data) {
      if (data) {
        instance.getCategories()
      }
    })
  },
  methods: {
    async getCategories() {

      const response = await fetch(HOST_API + `/categories/`, {
        method: 'GET',
        headers: {
          'Content-Type': 'application/json',
          'Authorization': `Bearer ${this.store.state.authentication.access}`,
        }
      })
      this.store.state.categories = await response.json()

      this.categories = this.store.state.categories

      EventBus.emit('updated-count-categories', true)
    }
  }
}
</script>

<template>
  <div class="grid">
    <div class="col-12 xl:col-12">
      <div class="card">
        <h5>Categorías</h5>
        <DataTable
            v-if="categories"
            :value="categories"
            dataKey="id"
            :rows="5"
            :paginator="true"
            responsiveLayout="scroll">
          <Column field="name" header="Título" :sortable="true" style="width: 35%"></Column>
          <Column style="width: 15%">
            <template #header> Ver</template>
            <template #body="slotProps">
              <router-link :to="{name: 'category_edit', params: {'id': slotProps.data.id}}">
                <Button icon="pi pi-search" type="button" class="p-button-text"></Button>
              </router-link>
            </template>
          </Column>
        </DataTable>
      </div>
    </div>
  </div>
</template>
